<?php
/*
Объект
&p=ThisComputer.Temperature	- Объект.Свойство

Выборка за последние:
&type=1z	- 1 месяц
&type=1d	- 1 день
&type=1h	- 1 час
&type=1m	- 1 минуту

Ручной период выборки:
	- календарный
	&start=14/09/19			- дата начала выборки(год/месяц/день)
	&end=14/09/22			- дата окончания выборки(год/месяц/день)
	- интервальный в секундах
	&starts=1411166970000		- дата начала выборки(год/месяц/день)
	&ends=1411200986000		- дата окончания выборки(год/месяц/день)	

&sp=m	- график по минутам(секунды обнуляем)
&sp=h	- график по часам (минуты и секунды обнуляем)
&sp=d	- график по дням(часы, минуты и секунды обнуляем)
&sp=z	- график по месяцам (дни, часы, минуты и секунды обнуляем)
	
*/

//---------------------------- Standard inclusions 
 
 chdir('../');
 include_once("./config.php");
 include_once("./lib/loader.php");
 include_once(DIR_MODULES."application.class.php");
 $db = new mysql(DB_HOST, '', DB_USER, DB_PASSWORD, DB_NAME); //connecting to database
 include_once("./load_settings.php");
 include("./pChart/pData.class");   
 include("./pChart/pChart.class");  
 
//---------------------------- Settings 

 $settings = SQLSelect("SELECT NAME, VALUE FROM settings");
 $total = count($settings);
 for($i=0;$i<$total;$i++) {
   Define('SETTINGS_'.$settings[$i]['NAME'], $settings[$i]['VALUE']);
 }

//---------------------------- Get object

 if ($p!='') {
 if (preg_match('/(.+)\.(.+)/is', $p, $m)) {
     $obj = getObject($m[1]);
     $prop_id = $obj->getPropertyByName($m[2], $obj->class_id, $obj->id);
   }
 }
 $pvalue=SQLSelectOne("SELECT * FROM pvalues WHERE PROPERTY_ID='".$prop_id."' AND OBJECT_ID='".$obj->id."'");
 if (!$pvalue['ID']) {exit;}

//---------------------------- end_time
 
 $end_time=time();

//---------------------------- start_time (end_time) & period def

 $start_time = 0;
   
 if (preg_match('/(\d+)d/', $type, $m)) 
 { //days (86400) &type=1d
   $total = (int)$m[1];
   $start_time = $end_time-$total*24*60*60;
 } elseif (preg_match('/(\d+)h/', $type, $m)) 
	{ //hours (3600) &type=1h
		$total = (int)$m[1];
		$start_time = $end_time-$total*60*60;
	} elseif (preg_match('/(\d+)m/', $type, $m)) 
		{ //minutes (60) &type=1m
			$total = (int)$m[1];
			$start_time = $end_time-$total*60;
		} elseif (preg_match('/(\d+)z/', $type, $m)) 
			{ //months (2678400) &type=1z
				$total = (int)$m[1];
				$start_time = $end_time-$total*31*24*60*60;
			}
			elseif (preg_match('/(\d+)\/(\d+)\/(\d+)/', $_GET['start'], $m) && preg_match('/(\d+)\/(\d+)\/(\d+)/', $_GET['end'], $n)) 
				{ // &start=14/09/19&end=14/09/22
					$start_time = mktime(0, 0, 0, $m[2], $m[3], $m[1]);
					$end_time = mktime(0, 0, 0, $n[2], $n[3], $n[1]);
				}
				elseif ($_GET['starts'] && $_GET['ends']) 
				{ 
					//$start_time = $_GET['starts']/1000-14400;
					//$end_time = $_GET['ends']/1000-14400;
					$start_time = $_GET['starts'];
					$end_time = $_GET['ends'];
				} // end if

	//echo $end_time."<br>";
	//echo $start_time."<br>";

//---------------------------- Get data from MySQL

$history = SQLSelect("SELECT UNIX_TIMESTAMP(ADDED) as UNX, VALUE FROM phistory WHERE VALUE_ID='".$pvalue['ID']."' AND ADDED>=('".date('Y-m-d H:i:s', $start_time)."') AND ADDED<=('".date('Y-m-d H:i:s', $end_time)."') ORDER BY ADDED");
$total=count($history);
//echo "<br/>total = ".$total."<br/>";

if ($_GET['sp']) $sp = $_GET['sp'];
 //else $sp = 0;
//echo $sp;
 
if ($total > 0) 
{
	printf("[");
	$first = false;
	$old_ADDED = 0;
	for($i=0;$i<$total;$i++) 
	 {
		$cur_ADDED = $history[$i]['UNX'];
   		if($old_ADDED != $cur_ADDED )
		    {
			if($first) printf(",");
			printf("[");
			//printf($history[$i]['UNX']);printf("   ");
			//printf($history[$i]['UNX']*1000+10800000);
			//echo date("  Y-m-d H:i:s",$history[$i]['UNX']*1000+10800000);//." = ".$history[$i]['UNX'];
			//printf($history[$i]['UNX']);
			
			$date_time_array = getdate($history[$i]['UNX']);
			$hours = $date_time_array['hours'];
			$minutes = $date_time_array['minutes'];
			$seconds = $date_time_array['seconds'];
			$month = $date_time_array['mon'];
			$day = $date_time_array['mday'];
			$year = $date_time_array['year'];

/*
&sp=m	- график по минутам(секунды обнуляем)
&sp=h	- график по часам (минуты и секунды обнуляем)
&sp=d	- график по дням(часы, минуты и секунды обнуляем)
&sp=z	- график по месяцам (дни, часы, минуты и секунды обнуляем)
*/
			
			if ($sp == 'h') {
				// Обнулим минуты и секунды (для графиков с почасовыми данными)
				$timestamp = mktime($hours,0,0,$month,$day,$year);
				printf($timestamp*1000+10800000);
				//echo date("  Y-m-d H:i:s", $timestamp);
			}
			else if ($sp == 'm') {
					$timestamp = mktime($hours,$minutes,0,$month,$day,$year);
					printf($timestamp*1000+10800000);
				}
				else if ($sp == 'd') {
						//$timestamp = mktime($hours,$minutes,0,$month,$day,$year);
						$timestamp = mktime(0,0,0,$month,$day,$year);
						printf($timestamp*1000+10800000);
					}
					else if ($sp == 'z') {
							$timestamp = mktime(0,0,0,$month,0,$year);
							printf($timestamp*1000+10800000);
						}			
						else {
							printf($history[$i]['UNX']*1000+10800000);
						}
			
			//echo date("  Y-m-d H:i:s",$timestamp);//." = ".$history[$i]['UNX'];
			//printf($history[$i]['UNX']);
			printf(", ");
			printf($history[$i]['VALUE']);
			printf("]");
			$old_ADDED = $history[$i]['UNX'];
			$first = true;
		    }
		
	 }
	printf("]");
}
//echo date_format(1424883609000, 'U = Y-m-d H:i:s') . "\n";


//---------------------------- Disconnect

 $db->Disconnect(); // closing database connection

?>
